Cosplay = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0")
local L = AceLibrary("AceLocale-2.2"):new("Cosplay")
L:RegisterTranslations("enUS", function() return {
	["Undress"] = true,
	["Target"] = true,
	["Open the DressUpFrame"] = true,
	["Undress Button"] = true,
} end)

-- Bindings
BINDING_NAME_CosplayButtonName = L["Open the DressUpFrame"]
BINDING_NAME_CosplayButtonHeader = L["Undress Button"]

function Cosplay:OnInitialize()
	local DUFUndressButton = CreateFrame("Button", "DUFUndressButton", DressUpFrame, "UIPanelButtonTemplate")
	DUFUndressButton:SetWidth(80)
	DUFUndressButton:SetHeight(22)
	DUFUndressButton:SetText(L["Undress"])
	DUFUndressButton:SetPoint("RIGHT", "DressUpFrameResetButton", "LEFT", 0, 0)
	DUFUndressButton:SetScript("OnClick", function()
		DressUpModel:Undress()
		PlaySound("gsTitleOptionOK")
	end)

	local DUFDressTargetButton = CreateFrame("Button", "DUFDressTargetButton", DressUpFrame, "UIPanelButtonTemplate")
	DUFDressTargetButton:SetWidth(80)
	DUFDressTargetButton:SetHeight(22)
	DUFDressTargetButton:SetText(L["Target"])
	DUFDressTargetButton:SetPoint("RIGHT", "DUFUndressButton", "LEFT", 0, 0)
	DUFDressTargetButton:SetScript("OnClick", function()
		self:DressUpTarget()
	end)
	DUFDressTargetButton:SetScript("OnShow", function()
		self:Reset()
	end)
end

function Cosplay:OnEnable()
	self:RegisterEvent("AUCTION_HOUSE_SHOW", "CreateAHButtons")
end

local buttonsCreated = false
function Cosplay:CreateAHButtons()
	if not buttonsCreated then
		local AuctionDUFUndressButton = CreateFrame("Button", "ADUFUndressButton", AuctionDressUpModel, "UIPanelButtonTemplate")
		ADUFUndressButton:SetWidth(70)
		ADUFUndressButton:SetHeight(22)
		ADUFUndressButton:SetText(L["Undress"])
		ADUFUndressButton:SetPoint("BOTTOM", "AuctionDressUpFrameResetButton", "TOP", 0, 2)
		ADUFUndressButton:SetScript("OnClick", function()
			AuctionDressUpModel:Undress()
			PlaySound("gsTitleOptionOK")
		end)

		buttonsCreated = true
	end
	self:UnregisterEvent("AUCTION_HOUSE_SHOW")
end

function Cosplay:Reset()
	SetPortraitTexture(DressUpFramePortrait, "player")
	SetDressUpBackground()
	DressUpModel:SetUnit("player")
end

function Cosplay:DressUpTarget()
	if not DressUpFrame:IsVisible() then
		ShowUIPanel(DressUpFrame)
	else
		PlaySound("gsTitleOptionOK")
	end
	if UnitIsVisible("target") then
		SetPortraitTexture(DressUpFramePortrait, "target")
		self:SetDressUpTargetBackground()
		DressUpModel:SetUnit("target")
	else
		self:Reset()
	end
end

function Cosplay:DressUpTargetTexturePath()
	local race, fileName = UnitRace("target")
	if fileName then
		if string.lower(fileName) == "gnome" then
			fileName = "Dwarf"
		elseif string.lower(fileName) == "troll" then
			fileName = "Orc"
		end
	else
		fileName = "Orc"
	end

	return "Interface\\DressUpFrame\\DressUpBackground-"..fileName
end

function Cosplay:SetDressUpTargetBackground()
	local texture = self:DressUpTargetTexturePath()
	DressUpBackgroundTopLeft:SetTexture(texture..1)
	DressUpBackgroundTopRight:SetTexture(texture..2)
	DressUpBackgroundBotLeft:SetTexture(texture..3)
	DressUpBackgroundBotRight:SetTexture(texture..4)
end
